#include "syswork.h"

//------------------------------------------
// ʂtbV
// r,g,b ̃IuWFNgɎw
//------------------------------------------
void obj_screeneffect_flash(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:{
	  	GsBOXF box;
		box.r = obj->r;
		box.g = obj->g;
		box.b = obj->b;
		box.attribute = (1<<30);
		box.x = LEFT;	box.y = TOP;
		box.w = FRAME_W;box.h = FRAME_H;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	obj->step = OBJ_END;
	  	break;
	  }
	  case OBJ_END:
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_screeneffect_wipeout(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	RECT rect;
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->h = FRAME_H;
	  	obj->y.h[1] = 0;
	  	obj->step = OBJ_MAIN;
	  	sysw->clearF = FALSE;
	  	break;
	  case OBJ_MAIN:
	  	setRECT(&rect,0,obj->y.h[1],FRAME_W,obj->h);
		//rect.x = 0;			rect.y = obj->y.h[1];
		//rect.w = FRAME_W;	rect.h = obj->h;
	  	GsSetClip2D(&rect);
	  	obj->y.h[1] += 10;
	  	obj->h -= 20;
	  	if(obj->h <= 0) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->clearF = TRUE;
	  	setRECT(&rect,0,0,FRAME_W,FRAME_H);
		//rect.x = 0;			rect.y = 0;
		//rect.w = FRAME_W;	rect.h = FRAME_H;
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_screeneffect_wipein(OBJECT*obj)
{
	RECT rect;
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->h = 0;
	  	obj->y.h[1] = FRAME_H/2;
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	setRECT(&rect,0,obj->y.h[1],FRAME_W,obj->h);
	  	//rect.x = 0;			rect.y = obj->y.h[1];
	  	//rect.w = FRAME_W;	rect.h = obj->h;
	  	GsSetClip2D(&rect);
	  	obj->y.h[1] -= 10;
	  	obj->h += 20;
	  	if(obj->h >= FRAME_H) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	setRECT(&rect,0,0,FRAME_W,FRAME_H);
		//rect.x = 0;			rect.y = 0;
		//rect.w = FRAME_W;	rect.h = FRAME_H;
	  	GsSetClip2D(&rect);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_screeneffect_fadeout_black2(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	GsBOXF box;
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->r = obj->g = obj->b = 0;
	  	obj->step = OBJ_MAIN;
	  	sysw->clearf = FALSE;
	  	break;
	  case OBJ_MAIN:
	  	obj->r += 8;
	  	obj->g += 8;
	  	obj->b += 8;
	  	box.attribute = (1<<30)|(2<<28);
	  	box.x = LEFT;		box.y = TOP;
	  	box.w = FRAME_W;  	box.h = FRAME_H;
	  	box.r = obj->r;	  	box.g = obj->g;		box.b = obj->b;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	if(obj->r > 200) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:{
	  	RECT rect;
	  	sysw->clearf = TRUE;
	  	delete_object(obj->header.num);
	  	setRECT(&rect,0,0,0,0);
	  	//rect.x = rect.y = rect.h = rect.w = 0;
	  	GsSetClip2D(&rect);
  		create_object(ID_GsNODRAW,KIND_OTHER,(void*)obj_screeneffect_wipein,0,OBJECTMAX);
	  	break;
	  }
	}
}

void obj_screeneffect_fadein(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	GsBOXF box;
	switch(obj->step){
	  case OBJ_INIT:
	  	box.attribute = (1<<30)|(2<<28);
	  	obj->r = obj->g = obj->b = 255;
	  	obj->step = OBJ_MAIN;
	  	box.x = LEFT;		box.y = TOP;
	  	box.w = FRAME_W;  	box.h = FRAME_H;
	  	box.r = obj->r;	  	box.g = obj->g;		box.b = obj->b;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	break;
	  case OBJ_MAIN:
	  	obj->r -= 4;
	  	obj->g -= 4;
	  	obj->b -= 4;
	  	box.attribute = (1<<30)|(2<<28);
	  	box.x = LEFT;		box.y = TOP;
	  	box.w = FRAME_W;  	box.h = FRAME_H;
	  	box.r = obj->r;	  	box.g = obj->g;		box.b = obj->b;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	if(obj->r < 10) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:{
	  	delete_object(obj->header.num);
	  	break;
	  }
	}
}

void obj_screeneffect_fadeout_black(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	GsBOXF box;
	switch(obj->step){
	  case OBJ_INIT:
	  	box.attribute = (1<<30)|(2<<28);
	  	obj->r = obj->g = obj->b = 0;
	  	obj->step = OBJ_MAIN;
	  	box.x = LEFT;		box.y = TOP;
	  	box.w = FRAME_W;  	box.h = FRAME_H;
	  	box.r = obj->r;	  	box.g = obj->g;		box.b = obj->b;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	break;
	  case OBJ_MAIN:
	  	obj->r += 4;
	  	obj->g += 4;
	  	obj->b += 4;
	  	box.attribute = (1<<30)|(2<<28);
	  	box.x = LEFT;		box.y = TOP;
	  	box.w = FRAME_W;  	box.h = FRAME_H;
	  	box.r = obj->r;	  	box.g = obj->g;		box.b = obj->b;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	if(obj->r >240) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:{
	  	delete_object(obj->header.num);
	  	break;
	  }
	}
}

//-----------------------------------------------
// sNZZɂ G,B̒lX 0 ɂĂ
//-----------------------------------------------
void obj_screeneffect_fadeout_red(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	GsBOXF box;
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->r = obj->g = obj->b = 0;
	  	obj->step = OBJ_MAIN;
	  	sysw->clearf = FALSE;
	  	break;
	  case OBJ_MAIN:
	  	obj->g += 3;
	  	obj->b += 3;
	  	box.attribute = (1<<30)|(2<<28);
	  	box.x = LEFT;		box.y = TOP;
	  	box.w = FRAME_W;  	box.h = FRAME_H;
	  	box.r = 0;		  	box.g = obj->g;		box.b = obj->b;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	if(obj->g > 250) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:{
	  	RECT rect;
	  	sysw->clearf = TRUE;
	  	delete_object(obj->header.num);
	  	setRECT(&rect,0,0,0,0);
	  	//rect.x = rect.y = rect.h = rect.w = 0;
	  	GsSetClip2D(&rect);
  		create_object(ID_GsNODRAW,KIND_OTHER,(void*)obj_screeneffect_wipein,0,OBJECTMAX);
	  	break;
	  }
	}
}

//------------------------------------------------
// XN[GtFNg
//------------------------------------------------
void obj_screeneffect_ff7(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	GsSPRITE spr1,spr2;
	switch(obj->step){
	  case OBJ_INIT:{
	  	u_long*memadr = (u_long*)FREEMEM_TOP;
	  	RECT rect;
	  	int i;
		// store to memory
	  	setRECT(&rect,0,0,320,240);
	  	StoreImage(&rect,(u_long*)FREEMEM_TOP);
	  	MoveImage(&rect,0,0);
	  	MoveImage(&rect,0,240);
  		// set STP bit
	  	for(i=0;i<320*240/2;i++,memadr++)
    	    *memadr = *memadr | (1<<15) | (1<<31);
	  	// load to frame buffer
	  	setRECT(&rect,320,0,320,240);
	  	LoadImage(&rect,(u_long*)FREEMEM_TOP);
		obj->r = obj->g = obj->b = 128;
		obj->rotate = ONE;
	  	obj->scalex = obj->scaley = ONE;
	  	obj->y.h[1] = TOP;
	  	obj->step = OBJ_MAIN;
	  	sysw->clearf = FALSE;
	  	break;
	  }
	  case OBJ_MAIN:
	  	spr1.mx = 160;	spr1.my = 120;
	  	spr2.mx = 0;  	spr2.my = 120;
	  	spr1.x = spr2.x	= 0;
	  	spr1.y = spr2.y = 0;//obj->y.h[1];
	  	spr1.attribute = spr2.attribute = (1<<30)|(1<<28)|(2<<24);
	  	spr1.tpage = spr2.tpage = GetTPage(2,2,320,0);
	  	spr1.u = spr1.v = spr2.v = 0;
	  	spr2.u = 160;
	  	spr1.w = spr2.w = 160;
	  	spr1.h = spr2.h = 240;
	  	spr1.r = spr2.r = obj->r;
	  	spr1.g = spr2.g = obj->g;
	  	spr1.b = spr2.b = obj->b;
	  	spr1.scalex = spr2.scalex = obj->scalex;
	  	spr1.scaley = spr2.scaley = obj->scaley;
	  	spr1.rotate = spr2.rotate = obj->rotate;
		if(sysw->systimer%2){
		  	obj->rotate += ONE*8;
			obj->r += 4;	obj->g += 4;	obj->b += 4;
			obj->scalex += 20;	obj->scaley += 20;
			//obj->y.h[1]+=4;
		}
		GsSortSprite(&spr1,&(sysw->got[sysw->activebuff]),0);
		GsSortSprite(&spr2,&(sysw->got[sysw->activebuff]),0);
		if(obj->r == 200)
			create_object(ID_GsNODRAW,KIND_SCREEN_EFFECT,(void*)obj_screeneffect_fadeout_black2,obj->header.num-1,-1);
	  	if(obj->r == 0){
	  		obj->r = obj->g = obj->b = 0;
	  		obj->step=OBJ_END;
	  	}
	  	break;
	  case OBJ_END:
	  	delete_object(obj->header.num);
	  	break;
	}
}
