//--------------
// Q[C
//--------------
#include <stdio.h>
#include "syswork.h"
#include "gs2d.h"
#include "gs3d.h"
#include "objply.h"
#include "itemwin.h"
#include "title.h"
#include "map3d.h"
#include "ascii.h"
#include "window.h"
#include "effect.h"
#include "game.h"
#include "gameover.h"
#include "sound.h"
#include "demo.h"
#include "prologue.h"
#include "epilogue.h"

	// ֐vg^Cv
	static void game_init();
	static void game_title();
	static void game_demo();
	static void game_option();
	static void game_start();
	static void game_game();
	static void game_itemmenu();
	static void game_epilogue();
	static void game_over_death();
	static void game_over();
	static void game_end();
	void gamemain();


//--------------
// Q[
//--------------
static void game_init()
{
    SYS_W*sysw = GetSystemWorkAddr();

	DebugPrint("cd stop\n");
	cd_stop();
	DebugPrint("game_init\n");
    // 
    DebugPrint("loading tim image ... ");
    KsTimLoadImage(YUKA_TIM_ADDR);
    KsTimLoadImage(KABE_TIM_ADDR);		KsTimLoadImage(DOORKABE_TIM_ADDR);
    KsTimLoadImage(DOOR_TIM_ADDR);		KsTimLoadImage(ITEM_TIM_ADDR);
	KsTimLoadImage(TITLE_TIM_ADDR);		KsTimLoadImage(MAPBLOCK_TIM_ADDR);
    KsTimLoadImage(BOMB1_TIM_ADDR);		KsTimLoadImage(BOMB2_TIM_ADDR);
    KsTimLoadImage(BOMB3_TIM_ADDR);		KsTimLoadImage(BOMB4_TIM_ADDR);
    KsTimLoadImage(ICON_TIM_ADDR);
	DebugPrint("complete.\n");

    DebugPrint("mapping modeing data ... ");
    KsGsMapModelingData((u_long*)MAN_TMD_ADDR);		KsGsMapModelingData((u_long*)YUKA_TMD_ADDR);
    KsGsMapModelingData((u_long*)KABE_TMD_ADDR);	KsGsMapModelingData((u_long*)DOORKABE_TMD_ADDR);
    KsGsMapModelingData((u_long*)DOOR_TMD_ADDR);	KsGsMapModelingData((u_long*)ENEMY1_TMD_ADDR);

    KsGsMapModelingData((u_long*)ITEM_DRINK_TMD_ADDR);		KsGsMapModelingData((u_long*)ITEM_REDBOOK_TMD_ADDR);
    KsGsMapModelingData((u_long*)ITEM_BLUEBOOK_TMD_ADDR);	KsGsMapModelingData((u_long*)ITEM_BOMB_TMD_ADDR);
    KsGsMapModelingData((u_long*)ITEM_CAKE_TMD_ADDR);	    KsGsMapModelingData((u_long*)ITEM_LIFE_TMD_ADDR);
    KsGsMapModelingData((u_long*)ITEM_STAR_TMD_ADDR);	    KsGsMapModelingData((u_long*)ITEM_RING_TMD_ADDR);
    KsGsMapModelingData((u_long*)ITEM_BLUEJUERY_TMD_ADDR);	KsGsMapModelingData((u_long*)ITEM_REDJUERY_TMD_ADDR);
    KsGsMapModelingData((u_long*)KONBOW_TMD_ADDR);			KsGsMapModelingData((u_long*)BANANA_TMD_ADDR);

    KsGsMapModelingData((u_long*)PS_TMD_ADDR);
    KsGsMapModelingData((u_long*)BOMB_TMD_ADDR);
    DebugPrint("complete.\n");
	sysw->systimer_sub=180;
    sysw->g_step = GAME_DEMO;
}

//--------------
// ^Cg
//--------------
static void game_title()
{
    SYS_W*sysw = GetSystemWorkAddr();
    //OBJECT*obj;

	sysw->demo_count = 0;
	if(!search_object_kind(KIND_TITLE)){
		create_object(ID_GsFASTSPRITE,KIND_TITLE,(void*)obj_title,0,-1);
		create_object(ID_GsNODRAW,KIND_SCREEN_EFFECT,(void*)obj_screeneffect_fadein,0,OBJECTMAX);
		return;
	}

    if((!sysw->padw[PAD1].new||(sysw->systimer_sub=TITLE_TIME*60))&&(sysw->systimer_sub-- == 0)){
		sysw->systimer_sub=180;
		delete_object(0);
		create_object(ID_GsNODRAW,KIND_SCREEN_EFFECT,(void*)obj_screeneffect_fadeout_black2,0,-1);
		sysw->g_step=GAME_DEMO;
    	return;
    }
}

//----------
// f
//----------
static void game_demo()
{
	//SYS_W*sysw=GetSystemWorkAddr();
	//sysw->difficult=1;
	demo_main();
}

//----------------
// IvV
//----------------
static void game_option()
{
	// IvV
}

static void game_start()
{
	SYS_W*sysw=GetSystemWorkAddr();
	// ̈s]vȕׂɂȂȂ悤 game_startƂ 1NbVu
	if(search_object_kind(KIND_SCREEN_EFFECT)) return;

	if(prologue()){
		draw_map(0);
		sysw->g_step = GAME_GAME;
		KsTimLoadImage(PS_TIM_ADDR);
		cd_play(1);
		// JnL^
		sysw->g_start = sysw->systimer;
	}
}


//------------------
// Q[{̂̏
//------------------
static void game_game()
{
	SYS_W*sysw=GetSystemWorkAddr();
	OBJECT*obj;

	// 3D}bv\
    draw_map(0);

    if (sysw->padw[PAD1].iskeydown & PADstart) sysw->pause ^= 1;
    if (sysw->pause){
    	gprintf16(0,-40,-8,"PAUSE");
    	sysw->systimer--;
    	return;
    }

	// ZNg{^vbVŌ݂̏ACe\
	if (sysw->padw[PAD1].iskeydown & PADselect){
		if(search_object_kind(KIND_SCREEN_EFFECT)) return;
		sysw->pause = 1;	// j[̓IuWFNg~߂
		sysw->g_step = GAME_ITEM_MENU;
		obj=create_object(ID_GsNODRAW,KIND_OTHER,(void*)obj_itemwindow,0,OBJECTMAX);
		obj->x.h[0] = GAME_GAME;
		return;
	}

	// bZ[W
	if((!sysw->pause) && (sysw->msg_expire-- == 0)) set_message("",-1);
	window_message(sysw->string);
    // ܂

    // vC[̃CtȂȂ
    if ((obj=search_object_kind(KIND_PLAYER1))&&(obj->life<=0)&&(obj->anim == getMaxTodFrame(obj->ptod))){
    	sysw->g_step = GAME_OVER_DEATH;
    	sysw->g_end = sysw->systimer;
    }
#if DEBUG

#endif
}

//--------------------------
// ACe\ƑI
//--------------------------
static void game_itemmenu()
{
	SYS_W*sysw=GetSystemWorkAddr();
	if(sysw->load < 250) VSync(0);
}

//----------------------
// PSQbgł
//----------------------
static void game_epilogue()
{
	SYS_W*sysw=GetSystemWorkAddr();
	OBJECT*scr=search_object_kind(KIND_SCREEN_EFFECT);
	if(scr){
		if(scr->step == OBJ_END){
			delete_object_all();
			create_object(ID_GsTOD,KIND_PLAYER1,(void*)obj_epilogue_player,0,-1);// vC[
			sysw->g_step = GAME_OVER_IN;
			sysw->systimer_sub = GAMEOVER_TIME*60;
		}
		return;
	}
	draw_map(0);
	epilogue_main();
}

//----------------
// ͐sē|ꂽ
//----------------
static void game_over_death()
{
	SYS_W*sysw=GetSystemWorkAddr();
	RECT rect;
   	// IuWFNgS폜
    sysw->score -= 10000;
    sysw->score = MAX(0,sysw->score);	// ̓_ɂȂĂ܂ 0
	delete_object_all();
	set_message("",-1);
	// ʃuh~
	setRECT(&rect,0,sysw->activebuff*240,320,240);
	MoveImage(&rect,0,(1-sysw->activebuff)*240);
	DrawSync(0);

	create_object(ID_GsNODRAW,KIND_SCREEN_EFFECT,(void*)obj_screeneffect_fadeout_red,OBJECTMAX-1,-1);
    sysw->systimer_sub = GAMEOVER_TIME*30;
    sysw->g_step = GAME_OVER;
}

static void game_over_in()
{
	SYS_W*sysw=GetSystemWorkAddr();
	if(sysw->load<250) VSync(0);
	if(search_object_kind(KIND_PLAYER1)) return;
    sysw->systimer_sub = GAMEOVER_TIME*30;
	sysw->g_step = GAME_OVER;
	return;
}

//------------------------
// Q[I[o[̏
//------------------------
static void game_over()
{
    if(search_object_kind(KIND_SCREEN_EFFECT)) return;
    gameover_main();
}

//------------------
// Q[Ȉ
//------------------
static void game_end()
{
	SYS_W*sysw=GetSystemWorkAddr();
    // I
    cd_stop();
    delete_object_all();
	create_object(ID_GsNODRAW,KIND_SCREEN_EFFECT,(void*)obj_screeneffect_fadeout_black2,0,-1);
    sysw->score = 0;
    sysw->msg_expire = 0;
    sysw->sel_item = 0;
    sysw->stars = 0;
    sysw->numofdamage = 0;
    sysw->numofhit = 0;
    sysw->numofattack = 0;
    sysw->pause = 0;
    sysw->clearF = TRUE;
    bzero((char*)sysw->item,sizeof(sysw->item));
    sysw->systimer_sub = 180;
    sysw->demo_count=0;
    KsTimLoadImage(PS_TIM_ADDR);
    sysw->g_step = GAME_DEMO;
}

void gamemain()
{
    SYS_W*sysw = GetSystemWorkAddr();
    switch(sysw->g_step){
      case GAME_INIT		:game_init();  break;
      case GAME_TITLE		:game_title(); break;
      case GAME_DEMO		:game_demo();  break;
      case GAME_OPTION		:game_option();break;
      case GAME_START		:game_start(); break;
      case GAME_ITEM_MENU	:game_itemmenu();break;
      case GAME_GAME		:game_game();  break;
      case GAME_EPILOGUE	:game_epilogue();break;
      case GAME_OVER_DEATH	:game_over_death();break;
      case GAME_OVER_IN		:game_over_in();break;
      case GAME_OVER		:game_over();  break;
      case GAME_END			:game_end();   break;
      default:break;
    }
}
