#include "syswork.h"
#include "game.h"
#include "sound.h"

enum{OBJ_PRINT=100};

//----------------------
// ACeIpWindow
//----------------------
void obj_itemwindow(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	GsBOXF box;
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	obj->x.h[1] = 0;	obj->y.h[1] = 0;
	  	obj->w = 0;			obj->h = 0;
	  	obj->status = sysw->sel_item;
	  	snd_on(SND_OPEN_WINDOW);
	  	break;
	  case OBJ_MAIN:
	  	box.attribute = (1<<30);
	  	box.x = obj->x.h[1];	box.y = obj->y.h[1];
	  	box.w = obj->w;			box.h = obj->h;
	  	box.r = 0;	box.g = 0;	box.b = 0;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	if(obj->y.h[1] >= TOP){
		  	obj->x.h[1] -= 8;	obj->y.h[1] -= 8;
	  		obj->w += 16;		obj->h += 16;
	  	}else obj->step = OBJ_PRINT;
	  	break;
	  case OBJ_END:
	  	box.attribute = (1<<30);
	  	box.x = obj->x.h[1];	box.y = obj->y.h[1];
	  	box.w = obj->w;			box.h = obj->h;
	  	box.r = 0;	box.g = 0;	box.b = 0;
	  	if(obj->y.h[1] <= 0){
		  	obj->x.h[1] += 16;	obj->y.h[1] += 16;
	  		obj->w -= 32;		obj->h -= 32;
	  	}else{
	  		sysw->g_step = obj->x.h[0];
	  		sysw->pause = 0;
	  		delete_object(obj->header.num);
	  		break;
	  	}
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);

	  	break;
	  case OBJ_PRINT:
		if(sysw->padw[PAD1].iskeydown & PADRright){
			// 
			obj->step = OBJ_END;
			sysw->sel_item = obj->status;
			snd_on(SND_OK);
		}
		if(sysw->padw[PAD1].iskeydown & PADRdown){
			// LZ
			obj->step = OBJ_END;
			snd_on(SND_CANCEL);
		}
		if(sysw->padw[PAD1].iskeydown & PADLup){
			// J[\
			obj->status--;
			if(obj->status<0) obj->status = ITEMMAX;
			snd_on(SND_CURSOR_MOVE);
		}
		if(sysw->padw[PAD1].iskeydown & PADLdown){
			// J[\
			obj->status++;
			if(obj->status>ITEMMAX) obj->status = 0;
			snd_on(SND_CURSOR_MOVE);
		}
		// I\
	  	KanjiFntPrint(sysw->fntstream2,"gȂ\n");	// sysw->sel_item = 0;
	  	KanjiFntPrint(sysw->fntstream2,"ΐFn}[F%d\n",sysw->item[ITEM_HEART]);	// sysw->sel_item = 1;
	  	KanjiFntPrint(sysw->fntstream2,"rEEEEF%d\n",sysw->item[ITEM_RING]);
	  	KanjiFntPrint(sysw->fntstream2,"Q^EEEEF%d\n",sysw->item[ITEM_DRINK]);
	  	KanjiFntPrint(sysw->fntstream2,"EEEEEF%d\n",sysw->item[ITEM_REDBOOK]);
	  	KanjiFntPrint(sysw->fntstream2,"JvZEEF%d\n",sysw->item[ITEM_BLUEBOOK]);
	  	KanjiFntPrint(sysw->fntstream2,"EEEEEF%d\n",sysw->item[ITEM_BOMB]);
	  	KanjiFntPrint(sysw->fntstream2,"_Ci}CgF%d\n",sysw->item[ITEM_BLUEJUERY]);
	  	KanjiFntPrint(sysw->fntstream2,"ogrEEEF%d\n",sysw->item[ITEM_REDJUERY]);	// sysw->sel_item = 8;
	  	KanjiFntPrint(sysw->fntstream2,"\nEEEEE\nLZEE~");
		// IJ[\
		box.attribute = (1<<30);
		box.w = 144;	box.h = 16;		box.x = LEFT+80;	box.y = TOP+30+ obj->status*16;
		box.r = 0;		box.g = 255;	box.b = 255;
		GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
		// 
	  	box.attribute = (1<<30);
	  	box.x = obj->x.h[1];	box.y = obj->y.h[1];	box.w = obj->w;	box.h = obj->h;
	  	box.r = 0;				box.g = 0;				box.b = 0;
	  	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	  	// \
	  	KanjiFntFlush(sysw->fntstream2);
	}
}
