#include <stdio.h>
#include "syswork.h"
#include "sound.h"

//----------------
// TEh
//----------------
int snd_init()
{
	SYS_W*sysw=GetSystemWorkAddr();
	sysw->ssvabid = SsVabTransfer((unsigned char*)SND_VH_ADDR,(unsigned char*)SND_VB_ADDR,-1,1);
	if(sysw->ssvabid < 0){
		printf("error: SsVabTransfer\n");
		return 0;
	}
	sysw->ssvoll=sysw->ssvolr=127;
	sysw->ssnote=60;
	SsSetMVol(sysw->ssvoll,sysw->ssvolr);
	SsSetSerialAttr(SS_CD, SS_MIX, SS_SON);	/* bcc``lL */
	SsSetSerialVol(SS_CD,127,127);	// CD volume
	return 1;
}

//----------------
// TEh炷
//----------------
int snd_on(short sndno)
{
	SYS_W*sysw=GetSystemWorkAddr();
	short voiceno;

	switch(sndno){
	  case SND_ASHIOTO:
	  	sysw->ssprog = 0;	sysw->sstone = 15;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_CURSOR_MOVE:
	  	sysw->ssprog = 0;	sysw->sstone = 0;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_OK:
	  case SND_CANCEL:
	  	sysw->ssprog = 0;	sysw->sstone = 10;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_GET_STAR:
	  case SND_OPEN_WINDOW:
	  	sysw->ssprog = 0;	sysw->sstone = 9;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_GET_ITEM:
	  	sysw->ssprog = 0;	sysw->sstone = 9;
	  	sysw->ssnote = 85;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_ENEMY_DAMAGE_PUNCH1:
	  	sysw->ssprog = 0;	sysw->sstone = 5;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_ENEMY_DAMAGE_PUNCH2:
	  	sysw->ssprog = 0;	sysw->sstone = 6;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_ASHIOTO_RUN:
	  	sysw->ssprog = 0;	sysw->sstone = 15;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_DAMAGE:
	  	sysw->ssprog = 0;	sysw->sstone = 12;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_KABE:
	  	sysw->ssprog = 0;	sysw->sstone = 11;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_SHOT:
	  	sysw->ssprog = 0;	sysw->sstone = 14;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  case SND_BAKUHATSU1:
	  	sysw->ssprog = 1;	sysw->sstone = 1;
	  	sysw->ssnote = 60;	sysw->ssfine = 0;
	  	sysw->ssvoll = sysw->ssvolr = 127;
	  	break;
	  default:
	  	sysw->ssprog=sysw->sstone=sysw->ssnote=sysw->ssfine=sysw->ssvoll=sysw->ssvolr= 0;
	  	break;
	}

	voiceno = SsUtKeyOn(sysw->ssvabid,sysw->ssprog,sysw->sstone,sysw->ssnote,sysw->ssfine,sysw->ssvoll,sysw->ssvolr);
	if(voiceno == -1){
		printf("error: SsUtKeyOn\n");
		return 0;
	}
#if DEBUG
	printf("voiceno:%d\n",voiceno);
#endif
	return 1;
}

//--------------------------
// ̃gbNĐ
//--------------------------
int cd_play(int track)
{
#if CDPLAY
	static int tracks[2];
	tracks[0]=track;
	tracks[1]=0;
	CdPlay(2,tracks,0);
#endif
	return TRUE;
}

//-----------------
// CD t~߂
//-----------------
int cd_stop()
{
#if CDPLAY
	CdPlay(0,0,0);
#endif
	return TRUE;
}
