#include "syswork.h"
#include "ascii.h"
#include "sound.h"
#include "game.h"
#include "effect.h"
#include "gs2d.h"


void obj_title(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();

	switch(obj->step){
	  case OBJ_INIT:
		sysw->clearR = sysw->clearG = sysw->clearB = 0;
		obj->r = obj->g = obj->b = 128;
		obj->cx = 0;
		obj->cy = 484;
		obj->w = 228;
		obj->h = 102;
		obj->x.h[1] = LEFT+46;
		obj->y.h[1] = TOP+20;
		obj->tpage = GetTPage(0,0,768,256);
		obj->u = 0;
		obj->v = 0;
		obj->attribute = 0;
		obj->step = OBJ_MAIN;
		KsTimLoadImage(TITLE_TIM_ADDR);
	  	break;
	  case OBJ_MAIN:
		// ^Cg\
		//gprintf16(0,LEFT+96,-16,"NO TITLE");
		//RotMatrixX(32,&(obj->lcoord.coord));
		if((sysw->systimer%60)<30) gprintf16(0,LEFT+72,BOTTOM-96,"PRESS START");
#ifndef CDPLAY
		gprintf8(0,LEFT,TOP,"No CD ver.");
#endif
		gprintf8(0,LEFT+176,BOTTOM-16,"PROGRAM T.MUNEMASA");

	    if(sysw->padw[PAD1].iskeydown & PADstart){
		    sysw->clearR = 0;	sysw->clearG = 0;	sysw->clearB = 0;
    		// Q[ɕKvȃIuWFNg
			create_object(ID_GsNODRAW,KIND_SCREEN_EFFECT,(void*)obj_screeneffect_fadeout_black2,OBJECTMAX-1,-1);
    		// vC[ 0 ɒu
    	    sysw->g_step = GAME_START;
    	    sysw->systimer_sub=180;
    	    obj->step = OBJ_END;
        	return;
	    }
	  	break;
	  case OBJ_END:
		delete_object(obj->header.num);
	  	break;
	}
	return;
}
