//---------------------
// asciitHgf[^
//---------------------

#include <stdarg.h>
#include <ctype.h>
#include "syswork.h"
#include "gs2d.h"
#include "ascii.h"
#include "lib.h"

//--------------------------
// AXL[tHg[h
//--------------------------
void loadfntdata()
{
    KsTimLoadImage(ASCI0_ADDR);
    KsTimLoadImage(ASCI1_ADDR);
    KsTimLoadImage(ASCI2_ADDR);
    KsTimLoadImage(ASCI3_ADDR);
    return;
}

//-----------------------------------------
// Cӂ̈ʒuɈꕶ\ 8dot charactor
//-----------------------------------------
void gputchar8(int pri,u_char ch,int x,int y)
{
    SYS_W*sysw=GetSystemWorkAddr();
    GsSPRITE sprite;

    sprite.attribute = (1<<30);
    sprite.x = x;
    sprite.y = y;
    sprite.w = sprite.h = 8;
    sprite.cx = ASCI0_CLUT_X;
    sprite.cy = ASCI0_CLUT_Y;
    sprite.u = (ch%16)*8;
    sprite.v = (ch/16)*8;
    sprite.r  = sprite.g  = sprite.b = 128;
    sprite.mx = sprite.my = 0;
    sprite.scalex = sprite.scaley = ONE;
    sprite.rotate = 0;
    sprite.tpage = GetTPage(0,0,ASCI0_TIM_X,ASCI0_TIM_Y);
    GsSortFastSprite(&sprite,&(sysw->got[sysw->activebuff]),pri);
    return;
}

//-----------------------------------------
// Cӂ̈ʒuɕ\(ASCI0.TIM)
//-----------------------------------------
void gputs8(int pri,int x,int y,u_char*str)
{
    SYS_W*sysw=GetSystemWorkAddr();
    GsSPRITE sprite;

    sprite.attribute = (1<<30);
    sprite.w = sprite.h = 8;
    sprite.x = x;
    sprite.y = y;
    sprite.cx = ASCI0_CLUT_X;
    sprite.cy = ASCI0_CLUT_Y;
    sprite.r  = sprite.g  = sprite.b = 128;
    sprite.mx = sprite.my = 0;
    sprite.scalex = sprite.scaley = ONE;
    sprite.rotate = 0;
    sprite.tpage = GetTPage(0,0,ASCI0_TIM_X,ASCI0_TIM_Y);

    while(*str != '\0'){
        sprite.u = ((*str)%16)*8;
        sprite.v = ((*str)/16)*8;
        GsSortFastSprite(&sprite,&(sysw->got[sysw->activebuff]),pri);
        sprite.x+= 8;
        str++;
    }
    return;
}

/*
    % [flag] [width] type_char

    [flag]    lɂ邩Elɂ邩
    [width]   o͂ŏ , ] 0 Ŗ߂邩
    type_char ϊw蕶(K{)

    [flag]    | - lɂB[width]̏̕ꍇ padding charactor ' '
    [width]   | W C CuɂقڏB
    type_char | d 10i
              | x 16i
              | s NULL^[~l[^܂ł̕
              | c P
              | %  %

    bugs:
        gputs8()yɂĂ邽߁A
        ̕\ƂȂƃpPbg𑽂

    int x       : XW
    int y       : YW
    GsOT*got    : `悵OTւ̃|C^
    char*format : W C Cu֏(ڂ͑Oq)

*/
//-----------------------
// printf  ASCI0.TIM
//-----------------------
void gprintf8(int pri,int x,int y,const char*format, ...)
{
    unsigned int num=0;     // %d,%x
    int width=0;
    int isleft=0;
    int i;
    char*string;            //
    char*vastr;             // %s
    char buf[16];           // %d,%x -> string ,, buf[0]=%c
    char workbuf[200];
    char pad=' ';           // padding charactor
    va_list ap;

    va_start(ap,format);

    string = workbuf;

    while(*format){
        switch(*format){
          case '%':
            format++;
            while(*format){
                switch(*format){
                  case '0':
                    if (width==0 && pad==' ' && isleft==0) pad='0';
                    else width*=10;
                    break;
                  case '1'...'9':
                    width=width*10+(*format)-'0';
                    break;
                  case '-':
                    if(width==0) isleft=1;
                    break;
                  case '%':
                    *(string++) = '%';
                    goto do_percent;
                    break;
                  case 's':
                    vastr = (char *) va_arg(ap, const char *);
                    if(isleft){
                        int n=strlen(vastr);
                        while (*vastr) *(string++) = *(vastr++);
                        if(width>n) for(i=0;i<(width-n);i++) *(string++) = pad;
                    }else{
                        if(width>strlen(vastr)) for(i=0;i<(width-strlen(vastr));i++) *(string++) = pad;
                        while (*vastr) *(string++) = *(vastr++);
                    }
                    goto do_percent;
                    break;
                  case 'c':
                    do{
                        buf[0] = (unsigned char)va_arg(ap,int); // Promoted.
                        *(string++) = buf[0];
                    }while(width--);
                    goto do_percent;
                    break;
                  case 'd':
                  case 'x':
                  case 'X':
                    num=va_arg(ap,int);
                    int2str(num,buf, (*format)=='d'?10:16 );
                    if(isleft){
                        for(i=0;(i<16)&&(buf[i]!=0);i++) *string++ = buf[i];
                        if(width>strlen(buf)) for(i=0;i<(width-strlen(buf));i++) *string++ = pad;
                    }else{
                        if(width>strlen(buf)) for(i=0;i<(width-strlen(buf));i++) *string++ = pad;
                        for(i=0;(i<16)&&(buf[i]!=0);i++) *string++ = buf[i];
                    }
                    goto do_percent;
                    break;
                  default:
                    goto do_percent;
                }
                format++;
            }
          do_percent:
            num=width=isleft=0;
            pad=' ';
            break;
          case '\n':
            *string=0;
            gputs8(pri,x,y,workbuf);
            y+=8;
            string=workbuf;
            break;
          default:
            *string++ = *format;
            break;
        }

        format++;
    }
    *string='\0';

    va_end(ap);

    gputs8(pri,x,y,workbuf);

    return;
}

//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
void gputs16(int pri,int x,int y,u_char*str)
{
    SYS_W*sysw=GetSystemWorkAddr();
    GsSPRITE sprite;

    sprite.attribute = (1<<30);
    sprite.w = sprite.h = 16;
    sprite.x = x;
    sprite.y = y;
    sprite.cx = ASCI1_CLUT_X;
    sprite.cy = ASCI1_CLUT_Y;
    sprite.r  = sprite.g  = sprite.b = 128;
    sprite.mx = sprite.my = 0;
    sprite.scalex = sprite.scaley = ONE;
    sprite.rotate = 0;
    sprite.tpage = GetTPage(0,0,ASCI0_TIM_X,ASCI0_TIM_Y);
    while(*str != '\0'){
    	if(*str == ' ') (*str)=0;
    	if(*str >= '0' && *str <= '9') (*str) -= 0x2f;
    	if(*str >= 'A' && *str <= 'Z') (*str) -= 0x36;
    	if(*str >= 'a' && *str <= 'z') (*str) -= 0x3c;
        sprite.u = 128+((*str)%8)*16;
        sprite.v = ((*str)/8)*16;
        GsSortFastSprite(&sprite,&(sysw->got[sysw->activebuff]),pri);
        sprite.x+= 16;
        str++;
    }
    return;
}

void gprintf16(int pri,int x,int y,const char*format, ...)
{
    unsigned int num=0;     // %d,%x
    int width=0;
    int isleft=0;
    int i;
    char*string;            //
    char*vastr;             // %s
    char buf[16];           // %d,%x -> string ,, buf[0]=%c
    char workbuf[200];
    char pad=' ';           // padding charactor
    va_list ap;

    va_start(ap,format);

    string = workbuf;

    while(*format){
        switch(*format){
          case '%':
            format++;
            while(*format){
                switch(*format){
                  case '0':
                    if (width==0 && pad==' ' && isleft==0) pad='0';
                    else width*=10;
                    break;
                  case '1'...'9':
                    width=width*10+(*format)-'0';
                    break;
                  case '-':
                    if(width==0) isleft=1;
                    break;
                  case '%':
                    *(string++) = '%';
                    goto do_percent;
                    break;
                  case 's':
                    vastr = (char *) va_arg(ap, const char *);
                    if(isleft){
                        int n=strlen(vastr);
                        while (*vastr) *(string++) = *(vastr++);
                        if(width>n) for(i=0;i<(width-n);i++) *(string++) = pad;
                    }else{
                        if(width>strlen(vastr)) for(i=0;i<(width-strlen(vastr));i++) *(string++) = pad;
                        while (*vastr) *(string++) = *(vastr++);
                    }
                    goto do_percent;
                    break;
                  case 'c':
                    do{
                        buf[0] = (unsigned char)va_arg(ap,int); // Promoted.
                        *(string++) = buf[0];
                    }while(width--);
                    goto do_percent;
                    break;
                  case 'd':
                  case 'x':
                  case 'X':
                    num=va_arg(ap,int);
                    int2str(num,buf, (*format)=='d'?10:16 );
                    if(isleft){
                        for(i=0;(i<16)&&(buf[i]!=0);i++) *string++ = buf[i];
                        if(width>strlen(buf)) for(i=0;i<(width-strlen(buf));i++) *string++ = pad;
                    }else{
                        if(width>strlen(buf)) for(i=0;i<(width-strlen(buf));i++) *string++ = pad;
                        for(i=0;(i<16)&&(buf[i]!=0);i++) *string++ = buf[i];
                    }
                    goto do_percent;
                    break;
                  default:
                    goto do_percent;
                }
                format++;
            }
          do_percent:
            num=width=isleft=0;
            pad=' ';
            break;
          case '\n':
            *string=0;
            gputs16(pri,x,y,workbuf);
            y+=16;
            string=workbuf;
            break;
          default:
            *string++ = *format;
            break;
        }

        format++;
    }
    *string='\0';

    va_end(ap);

    gputs16(pri,x,y,workbuf);

    return;
}
