#include <stdlib.h>
#include "syswork.h"
#include "gs3d.h"
#include "sincos.h"
#include "atan3.h"
#include "ascii.h"
#include "sound.h"


enum {
	BOSS_STOP=0,
	BOSS_WALK,
	BOSS_BACK,
	BOSS_PUNCH1,
	BOSS_PUNCH2,
	BOSS_RIGHT,
	BOSS_LEFT,
};

char *bossdemo_msg[]={
/*"@@@@@@@@@@@@@@@@@@@@",*/
  "@@@悭܂łǂ蒅",
  "@@@@@@ق߂Ă낤",
  "@|ʌ肱͎ɓ",
  "@@@@@@@I",
};

int view_boss_set2()
{
	SYS_W*sysw=GetSystemWorkAddr();
	int flg;
	flg=0;
   	sysw->view.vpx = 0;
   	if(sysw->view.vpy < 0xfffff9c0){
   		sysw->view.vpy += 128;
   		flg=1;
   	}
	flg=0;
   	if(sysw->view.vpz > 0x4b0){
   		sysw->view.vpz -= 128;
   		flg=1;
   	}
	flg=0;
   	sysw->view.vrx = 0;
   	if(sysw->view.vrz > 0xffffff9c){
   		sysw->view.vrz -= 128;
   		flg=1;
   	}
   	return flg;
}

int view_boss_set()
{
	SYS_W*sysw=GetSystemWorkAddr();
	int flg;
	flg=0;
	if(abs(sysw->view.vpz - 0xfffff9c0) > 100){
		sysw->view.vpz-=100;
		flg=1;
	}
	if(abs(sysw->view.vrz - 0xfffff128) > 100){
		sysw->view.vrz-=100;
		flg=1;
	}
	return flg;
}

int boss_in_demo()
{
	SYS_W*sysw=GetSystemWorkAddr();
	GsBOXF box;
	if(view_boss_set2()) return 0;
	if(view_boss_set()) return 0;
	if(sysw->systimer_sub-- <=0){
		sysw->demo_count++;
		sysw->systimer_sub=70;
	}
	if(sysw->demo_count == 2) cd_play(4);
	if(sysw->demo_count > 3) return 1;
	box.attribute = (1<<30)|(2<<28);
	box.x = LEFT;
	box.y = BOTTOM-72;
	box.w = 320;
	box.h = 32;
	box.r = box.g = box.b = 128;//40;
	GsSortBoxFill(&box,&(sysw->got[sysw->activebuff]),0);
	KanjiFntPrint(sysw->fntstream3,bossdemo_msg[sysw->demo_count]);
	KanjiFntFlush(sysw->fntstream3);
	return 0;
}

//-------------------------------------------------------------------------------
// IuWFNg
// [JW_IuWFNgXZʒɁATCY2000x2000ł邱ƂO
//-------------------------------------------------------------------------------
static int obj_hit_kabe(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
    int x1,x2,z1,z2;

    x1=(obj->lcoord.coord.t[0]+400)/2000;	x2=(obj->lcoord.coord.t[0]-400)/2000;
    z1=(obj->lcoord.coord.t[2]+400)/2000;	z2=(obj->lcoord.coord.t[2]-400)/2000;
    limitRange(x1,0,MAP_BLOCK_SIZE-1);		limitRange(x2,0,MAP_BLOCK_SIZE-1);
    limitRange(z1,0,MAP_BLOCK_SIZE-1);		limitRange(z2,0,MAP_BLOCK_SIZE-1);

	// ʍss\͈͂ɔэ񂾂
    if((sysw->mapdata[x1][z1]&8)==0 || (sysw->mapdata[x2][z2]&8)==0 ||
    	(sysw->mapdata[x1][z2]&8)==0 || (sysw->mapdata[x2][z1]&8)==0)	return 1;
    // Sg ubNɐiĂȂ
    if((sysw->mapdata[x1][z1] & 7)!=1 || (sysw->mapdata[x2][z2] & 7)!=1 ||
    	(sysw->mapdata[x2][z1] & 7)!=1 || (sysw->mapdata[x1][z2] & 7)!=1)	return 0;
    // ͊JĂ邩
    if((sysw->mapdata[x1][z1]&0x40) && (sysw->mapdata[x2][z2]&0x40) && (sysw->mapdata[x2][z1]&0x40) && (sysw->mapdata[x1][z2]&0x40)){
		// E
    	if((sysw->mapdata[x1][z1]&0x20)&&(obj->lcoord.coord.t[2]-400 >= z1*2000+300)&&(obj->lcoord.coord.t[2]+400 <= z1*2000+1700)){
    		return 0;
    	}
   		// O
    	if((sysw->mapdata[x1][z1]&0x10)&&(obj->lcoord.coord.t[0]-400 >= x1*2000+300)&&(obj->lcoord.coord.t[0]+400 <= x1*2000+1700)){
    		return 0;
    	}
        return 1;
    }else return 1;	// ͊JĂȂ
	// ubNI
}

static void boss_tod_stop(OBJECT*obj)
{
	obj->anim++;
	switch(obj->status){
	  case BOSS_WALK:
	  	obj->anim=1;
	  	obj->ptod = BOSS_TOD_WALK;
	  	break;
	  case BOSS_BACK:
	  	obj->anim=1;
	  	obj->ptod = BOSS_TOD_BACK;
	  	break;
	  case BOSS_PUNCH1:
	  	obj->anim=1;
	  	obj->ptod = BOSS_TOD_PUNCH1;
	  	break;
	  case BOSS_PUNCH2:
	  	obj->anim=1;
	  	obj->ptod = BOSS_TOD_PUNCH2;
	  	break;
	}
}

static void boss_tod_walk(OBJECT*obj)
{
	//SYS_W*sysw=GetSystemWorkAddr();
	//if((sysw->systimer%2)==0) obj->anim++;
	obj->anim++;
	switch(obj->status){
	  case BOSS_STOP:
	  	obj->anim=1;
	  	obj->ptod = BOSS_TOD_STOP;
	  	break;
	  case BOSS_BACK:
	  	obj->anim=1;
	  	obj->ptod = BOSS_TOD_BACK;
	  	break;
	  case BOSS_PUNCH1:
	  	obj->anim=1;
	  	obj->ptod = BOSS_TOD_PUNCH1;
	  	break;
	  case BOSS_PUNCH2:
	  	obj->anim=1;
	  	obj->ptod = BOSS_TOD_PUNCH2;
	  	break;
	}
}

static void boss_tod_back(OBJECT*obj)
{
	//SYS_W*sysw=GetSystemWorkAddr();
	//if((sysw->systimer%2)==0) obj->anim++;
	obj->anim++;
	switch(obj->status){
	  case BOSS_WALK:
		obj->anim=1;
		obj->ptod = BOSS_TOD_WALK;
		break;
	  case BOSS_STOP:
		obj->anim=1;
		obj->ptod = BOSS_TOD_STOP;
		break;
	  case BOSS_PUNCH1:
		obj->anim=1;
		obj->ptod = BOSS_TOD_PUNCH1;
		break;
	  case BOSS_PUNCH2:
		obj->anim=1;
		obj->ptod = BOSS_TOD_PUNCH2;
		break;
	}
}

static void boss_tod_punch1(OBJECT*obj)
{
  	if(obj->anim < getMaxTodFrame(obj->ptod)) obj->anim++;
  	else{
		obj->anim = 1;	obj->ptod = BOSS_TOD_STOP;
  	}
}

static void boss_tod_punch2(OBJECT*obj)
{
	if(obj->anim < getMaxTodFrame(obj->ptod)) obj->anim++;
	else{
		obj->anim = 1;	obj->ptod = BOSS_TOD_STOP;
  	}
}

static void obj_animation_boss(OBJECT*obj)
{
	switch(obj->ptod){
	  case BOSS_TOD_STOP:
	  	boss_tod_stop(obj);
	  	break;
	  case BOSS_TOD_WALK:
	  	boss_tod_walk(obj);
	  	break;
	  case BOSS_TOD_BACK:
	  	boss_tod_back(obj);
	  	break;
	  case BOSS_TOD_PUNCH1:
	  	boss_tod_punch1(obj);
	  	break;
	  case BOSS_TOD_PUNCH2:
	  	boss_tod_punch2(obj);
	  	break;
	}
    // Aj[Vt[̐
    if(obj->anim < 1) obj->anim = getMaxTodFrame(obj->ptod);
    if(obj->anim > getMaxTodFrame(obj->ptod)) obj->anim = 1;
}

static void obj_move_boss(OBJECT*obj)
{
	long x = obj->lcoord.coord.t[0];
	long y = obj->lcoord.coord.t[1];
	long z = obj->lcoord.coord.t[2];

	obj->lcoord.coord = GsIDMATRIX2;	// vC[̍Wn𐳋K
	obj->lcoord.coord.t[0] = x;	obj->lcoord.coord.t[1] = y;	obj->lcoord.coord.t[2] = z;	// W̕
    obj->rv.vy = obj->rotate;			// ݊pxۑ

    // E]
    //if(obj->status == BOSS_RIGHT) obj->rotate += 32;
    // ]
    //if(obj->status == BOSS_LEFT) obj->rotate -= 32;

    RotMatrixY( obj->rotate , &(obj->lcoord.coord));	// ]̕
    obj->rotate &= 0xfff;

    // Oi
    if((obj->ptod == BOSS_TOD_WALK)&&(obj->status == BOSS_WALK)){
   	    //obj->lcoord.coord.t[0] -= rsin(obj->rotate)*60/ONE;
   	    obj->lcoord.coord.t[0] -= rsin(obj->rotate)*60/ONE;
       	//if(obj_hit_kabe(obj)) obj->lcoord.coord.t[0] += rsin(obj->rotate)*60/ONE;
       	if(obj_hit_kabe(obj)) obj->lcoord.coord.t[0] += rsin(obj->rotate)*60/ONE;
        //obj->lcoord.coord.t[2] -= rcos(obj->rotate)*60/ONE;
        obj->lcoord.coord.t[2] -= rcos(obj->rotate)*60/ONE;
        //if(obj_hit_kabe(obj)) obj->lcoord.coord.t[2] += rcos(obj->rotate)*60/ONE;
        if(obj_hit_kabe(obj)) obj->lcoord.coord.t[2] += rcos(obj->rotate)*60/ONE;
    }
    // 
    if((obj->ptod == BOSS_TOD_BACK)&&(obj->status == BOSS_BACK)){
        obj->lcoord.coord.t[0] += rsin(obj->rotate)*30/ONE;
   	    if(obj_hit_kabe(obj)) obj->lcoord.coord.t[0] -= rsin(obj->rotate)*30/ONE;
       	obj->lcoord.coord.t[2] += rcos(obj->rotate)*30/ONE;
        if(obj_hit_kabe(obj)) obj->lcoord.coord.t[2] -= rcos(obj->rotate)*30/ONE;
    }
    limitRange(obj->lcoord.coord.t[0],400,MAP_BLOCK_SIZE*2000-400);
    limitRange(obj->lcoord.coord.t[2],400,MAP_BLOCK_SIZE*2000-400);	// tB[hTCYł̐
}

void boss_think(OBJECT*obj)
{
	//SYS_W*sysw=GetSystemWorkAddr();
	OBJECT*player=search_object_kind(KIND_PLAYER1);
	long dx,dz;
	short ang;

	// {IɑOi
	obj->status = BOSS_WALK;

	dx = obj->lcoord.coord.t[0] - rsin(obj->rotate)*400/ONE;
	dz = obj->lcoord.coord.t[2] - rcos(obj->rotate)*400/ONE;
	// ߐڍU\͈͓ɓp`1
	if(abs(dx-player->lcoord.coord.t[0])<400 && abs(dz-player->lcoord.coord.t[2])<400)
		obj->status = BOSS_PUNCH1;
	// Ȃp`2(𓊂)

	dx = obj->lcoord.coord.t[0] - player->lcoord.coord.t[0];
	dz = obj->lcoord.coord.t[2] - player->lcoord.coord.t[2];
	// vC[Ƃ̊px߂
	ang = atan3(dx,dz);//*360/4096;

	// vC[ߐڋɂBU[VŒ͉Ȃ
	if(abs(dx)<1000 && abs(dz)<1000 && obj->ptod != BOSS_TOD_PUNCH1 && obj->ptod != BOSS_TOD_PUNCH2){
		obj->rotate += 96;
		//obj->rotate = ang;
	}
	// vC[ւ̓]([VŒ̂)
	if(obj->ptod == BOSS_TOD_WALK){
		if(abs(obj->rotate - ang) < 384) obj->rotate = ang;
		else obj->rotate += 96;
	}

	//if((obj->status==BOSS_WALK)||(obj->status==BOSS_BACK)) obj->rotate = ang;

	obj->rotate &= 0xfff;
#if DEBUG
	gprintf8(0,0,16,"ang.%d",ang);
#endif
}

void obj_boss_die(OBJECT*obj)
{
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	break;
	  case OBJ_END:
	  	delete_object(obj->header.num);
	  	break;
	}
	return;
}

void obj_action_boss(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	GsInitCoordinate2(&sysw->world, &obj->lcoord);	// eW̊蓖
        obj->ptod = BOSS_TOD_STOP;
        obj->anim = 0;
        KsTODLinkObject(obj, (u_long*)obj->ptod, (u_long*)BOSS_TMD_ADDR);
        obj->anim++;
        obj->lcoord.coord.t[0] = 5000;
        obj->lcoord.coord.t[2] = 1000;	obj->lcoord.coord.t[1] = -50;
        obj->life = 30;
        obj->rotate = 2048;
        obj->status = BOSS_STOP;
	  	break;
	  case OBJ_MAIN:
	  	boss_think(obj);
	  	obj_animation_boss(obj);
	  	obj_move_boss(obj);

		if(obj->status == 0xff){
			obj->status = BOSS_BACK;
			obj->ptod = BOSS_TOD_BACK;
		}
	    obj->lcoord.flg=0;
	    KsTODLinkObject(obj,(u_long*)obj->ptod,(u_long*)BOSS_TMD_ADDR);
	    if(obj->life<=0) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:{
	  	OBJECT*objdie;
	  	objdie=create_object(ID_GsDOBJ2,KIND_OTHER,(void*)obj_boss_die,0,OBJECTMAX);
	  	if(objdie){
            GsInitCoordinate2(&(sysw->world),&(objdie->lcoord));
	  		KsTMDLinkObject(objdie,(u_long*)BOSS_TMD_ADDR,&(objdie->lcoord));
	  		objdie->lcoord.coord = obj->lcoord.coord;
	  		objdie->lcoord.coord.t[1] -= 100;
	  	}
  		delete_object(obj->header.num);
	  	break;
	  }
	}
}

void obj_action_boss_stop(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	GsInitCoordinate2(&sysw->world, &obj->lcoord);	// eW̊蓖
        obj->ptod = BOSS_TOD_STOP;
        obj->anim = 0;
        KsTODLinkObject(obj, (u_long*)obj->ptod, (u_long*)BOSS_TMD_ADDR);
        obj->anim++;
        obj->lcoord.coord.t[0] = 9*2000+1000;
        obj->lcoord.coord.t[2] = 10*2000+1000;
        obj->lcoord.coord.t[1] = -50;
        obj->life = 30;
        obj->rotate = 3072;
        obj->status = BOSS_STOP;
	  	break;
	  case OBJ_MAIN:
	  	obj_animation_boss(obj);
	  	obj_move_boss(obj);

	    obj->lcoord.flg=0;
	    KsTODLinkObject(obj,(u_long*)obj->ptod,(u_long*)BOSS_TMD_ADDR);
	  	break;
	  case OBJ_END:
	  	delete_object(obj->header.num);
	  	break;
	}
}
