#include <stdio.h>
#include <string.h>
#include "syswork.h"
#include "objsys.h"
#include "game.h"
#include "gs3d.h"
#include "gs2d.h"

//--------------
// fpPS\
//--------------
void obj_psdemo(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
		sysw->clearR = sysw->clearG = sysw->clearB = 0;

		sysw->view.vrx = sysw->view.vry = sysw->view.vrz = 0;
		sysw->view.vpx = 0;
		sysw->view.vpy = -1000;
		sysw->view.vpz = -3000;
		sysw->view.super = &(sysw->world);
		GsSetRefView2(&sysw->view);
		// sp[^ݒ
		sysw->light[0].vx= 0;	sysw->light[0].vy= 20000;	sysw->light[0].vz= 10000;
		sysw->light[0].r=0xff;	sysw->light[0].g=0xff;		sysw->light[0].b=0xff;
		GsSetFlatLight(0,&sysw->light[0]);
		KsTimLoadImage(PS_TIM_ADDR);
		break;
	  case OBJ_MAIN:
		RotMatrixY(32,&(obj->lcoord.coord));
		obj->lcoord.flg=0;
		break;
	  case OBJ_END:
		delete_object(obj->header.num);
		break;
	}
}


void obj_mapdemo(OBJECT*obj)
{
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->cx = 0;
	  	obj->cy = 487;
	  	obj->x.h[1] = LEFT+86;
	  	obj->y.h[1] = TOP+50;
	  	obj->tpage = GetTPage(0,0,896,0);
	  	obj->u = 0;
	  	obj->v = 104;
	  	obj->w = 148;
	  	obj->h = 70;
	  	obj->r = obj->g = obj->b = 128;
	  	obj->attribute = 1<<30;
	  	obj->step = OBJ_MAIN;
	    KsTimLoadImage(MAP_TIM_ADDR);

	  	break;
	  case OBJ_MAIN:
	  	break;
	  case OBJ_END:
	  	delete_object(obj->header.num);
	  	break;
	}
}

char *demo_msg[]={
  /*"@@@@@@@@@@@@@@@@@@@@",*/
	"@@@@@u~@^v",
	"",
	"@@@@@͑q̒a",
	"@@or~ƌĂ",
	"@@@@ǂŎɓ̂낤",
};

void demo_main()
{
	SYS_W*sysw=GetSystemWorkAddr();

	if(search_object_kind(KIND_SCREEN_EFFECT)) return;
	if(sysw->systimer_sub==179 && sysw->demo_count==0){
		RECT rect;
		setRECT(&rect, 0, 0, 320, 240);
	  	GsSetClip2D(&rect);
		create_object(ID_GsFASTSPRITE,KIND_OTHER,(void*)obj_mapdemo,0,-1);
	}
	if((sysw->systimer_sub-- <=0)||(sysw->padw[PAD1].iskeydown & PADRright)){
		sysw->demo_count++;
		sysw->systimer_sub=180;
		//if(demo_count==1) delete_object(0);
		if(strcmp(demo_msg[sysw->demo_count],"@@or~ƌĂ") == 0){
			OBJECT*obj;
			obj=create_object(ID_GsDOBJ2,KIND_PS,(void*)obj_psdemo,0,-1);
			GsInitCoordinate2(&(sysw->world),&(obj->lcoord));
			KsTMDLinkObject(obj,(u_long*)PS_TMD_ADDR,&(obj->lcoord));
			obj->lcoord.coord.t[0] = 0;
			obj->lcoord.coord.t[2] = 0;
		}
	}

	if((sysw->demo_count >=5)||(sysw->padw[PAD1].iskeydown & PADstart)){
		sysw->systimer_sub = TITLE_TIME*60;
		sysw->g_step=GAME_TITLE;
		sysw->demo_count = 0;
		return;
	}
	KanjiFntPrint(sysw->fntstream3,demo_msg[sysw->demo_count]);
	KanjiFntFlush(sysw->fntstream3);

	return;
}
