#include "syswork.h"
#include "ascii.h"
#include "map3d.h"
#include "sound.h"

void light_init()
{
	SYS_W*sysw=GetSystemWorkAddr();
	// CgID0 ݒ
	// sp[^ݒ
	sysw->light[0].vx= 0;
	sysw->light[0].vy= 10000;
	sysw->light[0].vz= 0;
	// sFp[^ݒ
	sysw->light[0].r=0xff;
	sysw->light[0].g=0xff;
	sysw->light[0].b=0xff;
	// p[^ݒ
	GsSetFlatLight(0,&sysw->light[0]);

	// CgID1 ݒ
	sysw->light[1].vx= 8000;
	sysw->light[1].vy= -500;
	sysw->light[1].vz= 8000;
	//sysw->light[1].r=0xff;
	//sysw->light[1].g=0xff;
	//sysw->light[1].b=0xff;
	sysw->light[1].r=128;
	sysw->light[1].g=128;
	sysw->light[1].b=128;
	GsSetFlatLight(1,&sysw->light[1]);
  
	// CgID2 ݒ
	sysw->light[2].vx= -8000;
	sysw->light[2].vy= 500;
	sysw->light[2].vz= -8000;
	//sysw->light[2].r=0xff;
	//sysw->light[2].g=0xff;
	//sysw->light[2].b=0xff;
	sysw->light[2].r=128;
	sysw->light[2].g=128;
	sysw->light[2].b=128;
	GsSetFlatLight(2,&sysw->light[2]);
	// ArGgݒ
	GsSetAmbient(ONE/8,ONE/8,ONE/8);

	// vZ̃ftHg̕ݒ
	// tHǑvZ
	GsSetLightMode(1);
	//GsSetLightMode(0);

	sysw->fog.dqa = -18000 * 4096/64/PROJECTION;
	sysw->fog.dqb =  20971520; // 1.25*4096*4096
	sysw->fog.rfc = 0;
	sysw->fog.gfc = 0;
	sysw->fog.bfc = 0;
	GsSetFogParam(&(sysw->fog));
}

//------------
// e평
//------------
void init()
{
	SYS_W*sysw=GetSystemWorkAddr();
	//RECT rect;

	// VXe[NƃIuWFNg[N̏
	SystemWorkInit();	// in syswork.c
	ObjectWorkInit();	// in objwork.c

	// `E\̐ݒ
	// mC^[X,GPUItZbg
	GsInitGraph(FRAME_W, FRAME_H, GsNONINTER | GsOFSGPU, 1, 0);
	GsDefDispBuff(FRAME_X1, FRAME_Y1, FRAME_X2, FRAME_Y2);
	GsInit3D();
	// OT̐ݒ
	sysw->got[0].length = OT_LENGTH;
	sysw->got[0].org = sysw->got_tag[0];
	sysw->got[1].length = OT_LENGTH;
	sysw->got[1].org = sysw->got_tag[1];

	// W̒`
	GsInitCoordinate2(WORLD,&sysw->world);
	// }gbNXvZ[Ñ[e[VxN^
	sysw->svector.vx = sysw->svector.vy = sysw->svector.vz = 0;
	// IuWFNǧ_[hZ = -4000ɐݒ
	sysw->world.coord.t[2] = -4000;

	// vWFNVݒ
	GsSetProjection(PROJECTION);
	// _p[^ݒ
   	// NEH[^[r[
    sysw->view.vpx = 0;
	sysw->view.vpy = 0xfffff6a0;
    sysw->view.vpz = 0xa8c;
	sysw->view.vrx = 0;
	sysw->view.vry = 0xfffffaec;
	sysw->view.vrz = 0;
	sysw->view.rz=0;
	// _̐eW
	sysw->view.super = WORLD;
	// [h/XN[ϊ}gNXvZ
	GsSetRefView2(&sysw->view);

	//light_init();

	sysw->clearR=0;
	sysw->clearG=0;
	sysw->clearB=0;
	sysw->clearf=TRUE;

	// t[obt@NA
	//setRECT(&rect,0,0,1023,511);
	//ClearImage(&rect,0x00,0x00,0x80);

	snd_init();
	// pbh̏
	PadInit();		// in pad.c
	loadfntdata();	// asciitHgvramփ[h in ascii.c
	init_map();

	KanjiFntClose(); // new libps
	sysw->fntstream =KanjiFntOpen(LEFT+8 ,BOTTOM-24,304 	   ,32		  ,320,256,0,485,0,19);
	sysw->fntstream2=KanjiFntOpen(LEFT+80 ,TOP+30  ,240 	   ,240 	  ,320,0  ,0,485,0,200);
	sysw->fntstream3=KanjiFntOpen(LEFT,BOTTOM-64,320,32,320,256,0,485,0,40);
}
