//------------------
// IuWFNg`
//------------------
#include "syswork.h"

//-----------------------------
// GsSPRITE (GsSortFastSprite)
//-----------------------------
void obj_draw_fastsprite(OBJECT*obj)
{
    SYS_W*sysw=GetSystemWorkAddr();
    GsSPRITE spr;

    spr.attribute = obj->attribute;
    spr.x = obj->x.h[1];
    spr.y = obj->y.h[1];
    spr.w = obj->w;
    spr.h = obj->h;
    spr.tpage = obj->tpage;
    spr.r = obj->r;
    spr.g = obj->g;
    spr.b = obj->b;
    spr.cx = obj->cx;
    spr.cy = obj->cy;
    spr.u = obj->u;
    spr.v = obj->v;
    GsSortFastSprite(&spr,&(sysw->got[sysw->activebuff]),obj->pri);
}

//-------------------------
// GsSPRITE (GsSortSprite)
//-------------------------
void obj_draw_sprite(OBJECT*obj)
{
    SYS_W*sysw=GetSystemWorkAddr();
    GsSPRITE spr;

    spr.attribute = obj->attribute;
    spr.x = obj->x.h[1];
    spr.y = obj->y.h[1];
    spr.w = obj->w;
    spr.h = obj->h;
    spr.tpage = obj->tpage;
    spr.r = obj->r;
    spr.g = obj->g;
    spr.b = obj->b;
    spr.cx = obj->cx;
    spr.cy = obj->cy;
    spr.u = obj->u;
    spr.v = obj->v;
    spr.mx = obj->mx;
    spr.my = obj->my;
    spr.scalex = obj->scalex;
    spr.scaley = obj->scaley;
    spr.rotate = obj->rotate;
    GsSortSprite(&spr,&(sysw->got[sysw->activebuff]),obj->pri);
}

//---------
// GsDOBJ2
//---------
void obj_draw_dobj2(OBJECT*obj)
{
    SYS_W       *sysw = GetSystemWorkAddr();
    KsGsDOBJ    *pdobj;
    GsDOBJ2     *op;    // IuWFNgnhւ̃|C^
    MATRIX      lsmatrix,lwmatrix;

    pdobj = obj->pdobj;
    while(obj->pdobj) {
        op = &(pdobj->object);
        // LW/LSϊ}gbNXvZ
        GsGetLws(op->coord2, &lwmatrix, &lsmatrix);
        // LW}gbNXݒ
        GsSetLightMatrix(&lwmatrix);
        // LS}gbNXݒ
        GsSetLsMatrix(&lsmatrix);
        // OT֓o^
        GsSortObject4(op, &(sysw->got[sysw->activebuff]),14-OT_LENGTH,getScratchAddr(0));
        if(!(pdobj->pafter)) break;
        pdobj++;
    }
}

//------------------
// GsDOBJ2 with TOD
//------------------
void obj_draw_tod(OBJECT*obj)
{
    SYS_W       *sysw = GetSystemWorkAddr();
    OBJ_W       *pobjw = GetObjectWorkAddr();
    KsGsDOBJ2   *pgsdobj2;
    int         n;
    GsDOBJ2     *op;    // IuWFNgnhւ̃|C^
    MATRIX      lwmatrix,lsmatrix;

    pgsdobj2 = pobjw->gsdobj2;
    for(n = 0 ; n < GSDOBJ2_MAX ; n++, pgsdobj2++) {
        if(pgsdobj2->pobj == (OBJ_HEADER*)obj) {
            op = &(pgsdobj2->object);
            // LW/LSϊ}gbNXvZ
            GsGetLws(op->coord2, &lwmatrix, &lsmatrix);
            // LW}gbNXݒ
            GsSetLightMatrix(&lwmatrix);
            // LS}gbNXݒ
            GsSetLsMatrix(&lsmatrix);
            // OT֓o^
            GsSortObject4(op, &(sysw->got[sysw->activebuff]),14-OT_LENGTH,getScratchAddr(0));
        }
    }
}

/*
//----------------------------
// [3DXvCg(eXg)
//----------------------------
void obj_draw_3dsprite(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	VECTOR dv;
	u_short fx,fy,otz;
	GsSPRITE spr;

	PushMatrix();

	// WSWϊ
	ApplyMatrixLV(&GsWSMATRIX,&(obj->sv),&dv);
	dv.vx += GsWSMATRIX.t[0];
	dv.vy += GsWSMATRIX.t[1];
	dv.vz += GsWSMATRIX.t[2];
	if(dv.vz < PROJECTION/2) goto End;
	fx = obj->w * 8 * PROJECTION / dv.vz;	// 8{ŕ`
	fy = obj->h * 8 * PROJECTION / dv.vz;	// 8{ŕ`
	if(fx>0 && fy>0){
		// ϊ
		dv.vx = dv.vx * PROJECTION / dv.vz;
		dv.vy = dv.vy * PROJECTION / dv.vz;
		spr.x = dv.vx - fx/2;
		spr.y = dv.vy - fy/2;
		spr.scalex = ONE * fx / obj->w;
		spr.scaley = ONE * fy / obj->h;
		otz = (u_short)(dv.vz >> (2+14-OT_LENGTH));

		spr.w = obj->w;
		spr.h = obj->h;
		spr.tpage = obj->tpage;
		spr.attribute = obj->attribute;
		spr.r = obj->r;
		spr.g = obj->g;
		spr.b = obj->b;
		spr.cx = obj->cx;
		spr.cy = obj->cy;
		spr.u = obj->u;
		spr.v = obj->v;
		spr.mx = obj->mx;
		spr.my = obj->my;
		spr.rotate = obj->rotate;
		GsSortSprite(&spr,&(sysw->got[sysw->activebuff]),otz);
	}

  End:
	PopMatrix();
}
*/
