//----------
// ACe
//----------
#include <stdlib.h>
#include "syswork.h"
#include "objthrow.h"
#include "game.h"
#include "gs3d.h"
#include "window.h"
#include "sincos.h"
#include "sound.h"


static void delete_map_item(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	char m = sysw->mapdata[obj->lcoord.coord.t[0]/2000][obj->lcoord.coord.t[2]/2000];
	sysw->mapdata[obj->lcoord.coord.t[0]/2000][obj->lcoord.coord.t[2]/2000] ^= m & 0xf0;
}

static int obj_player_get(OBJECT*obj)
{
	OBJECT*objply = search_object_kind(KIND_PLAYER1);
	int x1,z1,x2,z2,px,pz;

	//if(objply->status == 0x40) return 0;
	x1 = obj->lcoord.coord.t[0]+500;
	x2 = obj->lcoord.coord.t[0]-500;
	z1 = obj->lcoord.coord.t[2]+500;
	z2 = obj->lcoord.coord.t[2]-500;
	px = objply->lcoord.coord.t[0];
	pz = objply->lcoord.coord.t[2];
	// ႪޕKvȂ
	if((x1>px)&&(px>x2)&&(z1>pz)&&(pz>z2)) return 1;
	return 0;
}

void obj_item_konbow(OBJECT*obj)
{
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:{
	    int i,j;
		OBJ_W*objw=GetObjectWorkAddr();
		KsGsDOBJ2   *pgsdobj2 = objw->gsdobj2;
	  	OBJECT*player,*obj2;

	  	set_message("_QbgI",MSGTIME);
		snd_on(SND_GET_STAR);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);

		obj2=create_object(ID_GsDOBJ2,KIND_KONBOW,NULL,0,OBJECTMAX);
		player=search_object_kind(KIND_PLAYER1);
		KsTMDLinkObject(obj2,(u_long*)KONBOW_TMD_ADDR,&(obj2->lcoord));

		j=0;
   		for(i = 0 ; i < GSDOBJ2_MAX ; i++, pgsdobj2++){
			if(pgsdobj2->pobj == (OBJ_HEADER*)player) j++;
			if(j==10){
				GsInitCoordinate2(pgsdobj2->object.coord2,&(obj2->lcoord));
				break;
			}
   		}
   		RotMatrixX(1024,&(obj2->lcoord.coord));
   		obj2->lcoord.coord.t[1] = 500;

	  	break;
	  }
	}
}

void obj_item_banana(OBJECT*obj)
{
	switch(obj->step){
	  case OBJ_INIT:{
	  	VECTOR vector;
		//obj->lcoord.coord = GsIDMATRIX2;	// vC[̍Wn𐳋K
	    vector.vx = 1024;
	    vector.vy = 1024;
	    vector.vz = 1024;
	    ScaleMatrix(&(obj->lcoord.coord),&vector);
	    obj->lcoord.flg=0;
	    obj->lcoord.coord.t[1]= -150;
	  	obj->step=OBJ_MAIN;
	  	break;
	  }
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:{
	  	OBJECT*player=search_object_kind(KIND_PLAYER1);
	  	player->ptod = MAN_TOD_BANANA_SLIP;
	  	player->anim = 1;
	  	set_message("oii̔łׂI",MSGTIME);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	snd_on(SND_DAMAGE);
	  	break;
	  }
	}
}

void obj_item_ring(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->item[ITEM_RING]+=10-sysw->difficult*4;
	  	set_message("тQbgI",MSGTIME);
		snd_on(SND_GET_ITEM);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_item_drink(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->item[ITEM_DRINK]+=10-sysw->difficult*4;
	  	set_message("QbgI",MSGTIME);
		snd_on(SND_GET_ITEM);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_item_redbook(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	RotMatrixX(1024,&(obj->lcoord.coord));
	  	obj->lcoord.flg=0;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->item[ITEM_REDBOOK]+=10-sysw->difficult*4;
	  	set_message("QbgI",MSGTIME);
		snd_on(SND_GET_ITEM);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_item_bluebook(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->item[ITEM_BLUEBOOK]+=10-sysw->difficult*4;
	  	set_message("JvZQbgI",MSGTIME);
		snd_on(SND_GET_ITEM);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_item_bomb(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->item[ITEM_BOMB]+=10-sysw->difficult*4;
	  	set_message("QbgI",MSGTIME);
		snd_on(SND_GET_ITEM);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

//-----------------------------------------------
// P[LƃCt ^ƃCt_E
//-----------------------------------------------
void obj_item_cake(OBJECT*obj)
{
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)){
			OBJECT*objply=search_object_kind(KIND_PLAYER1);
	  		if((rand()%4)==0){
	  			// 1/4 ̊mŐH_[W
	  			objply->life -= 2;
	  			objply->life = MAX(objply->life,1);
	  			//objply->ptod = MAN_TOD_DAMAGE_START;
	  			//objply->anim = 1;
		  		set_message("EbIN ̂u́I",MSGTIME);
		  		snd_on(SND_DAMAGE);
	  		}else{
	  			objply->life += 2;
	  			objply->life = MIN(objply->life,MAXLIFE);
		  		set_message("Ct񕜁I",MSGTIME);
	  			snd_on(SND_GET_STAR);
			}
	  		obj->step = OBJ_END;
	  	}
	  	break;
	  case OBJ_END:
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_item_bluejuery(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->item[ITEM_BLUEJUERY]+=10-sysw->difficult*4;
	  	set_message("_Ci}CgQbgI",MSGTIME);
		snd_on(SND_GET_ITEM);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_item_redjuery(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->item[ITEM_REDJUERY]+=10-sysw->difficult*4;
	  	set_message("ogrQbgI",MSGTIME);
		snd_on(SND_GET_ITEM);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}


void obj_item_star(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	//OBJECT*objply=search_object_kind(KIND_PLAYER1);
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	break;
	  case OBJ_MAIN:
	  	// ͏R邱Ƃ͂łȂƂɂ
#if 0
	  	if(obj_player_kick(obj)){
			OBJECT*objkick;
			objkick=create_object(ID_GsDOBJ2,KIND_ATTACK,(void*)obj_kick_item,0,OBJECTMAX);
			setup_kick_object(objkick,ITEM_STAR_TMD_ADDR);
			delete_map_item(obj);
			delete_object(obj->header.num);
	  	}
#endif
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj))	obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	set_message("QbgI",MSGTIME);
		snd_on(SND_GET_STAR);
	  	sysw->stars++;
	  	sysw->stars = MIN(sysw->stars,5);
		if(obj->status == 0) delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_item_heart(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
 	  	break;
	  case OBJ_MAIN:
	  	// vC[ڐGĂ
	  	if(obj_player_get(obj)) obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	sysw->item[ITEM_HEART]+=10-sysw->difficult*4;
	  	set_message("n}[QbgI",MSGTIME);
		snd_on(SND_GET_ITEM);
	  	delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}

void obj_item_ps(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
	  	obj->lcoord.coord.t[1] -= 100;
	  	break;
	  case OBJ_MAIN:{
	  	// vC[ڐGĂ
	  	if(search_object_kind(KIND_BOSS)) break;
	  	if(obj_player_get(obj)){
	  		obj->step = OBJ_END;
	  		sysw->g_step = GAME_EPILOGUE;
	  	}
	  	break;
	  }
	  case OBJ_END:
	  	set_message("vCXe[VQbgI",MSGTIME);
		if(obj->status == 0) delete_map_item(obj);
	  	delete_object(obj->header.num);
	  	break;
	}
}
