//--------------------
// ACeR
//--------------------
#include "syswork.h"
#include "bomb.h"
#include "gs3d.h"
#include "sincos.h"
#include "sound.h"

static OBJECT*obj_hit_enemy(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	OBJECT*objenemy = (OBJECT*)GetObjectWorkAddr();
	int i;

	for(i=0;i<OBJECTMAX;i++,objenemy++){
		if(objenemy->header.kind == KIND_ENEMY1){
			int dx,dz;
			dx = abs(objenemy->lcoord.coord.t[0] - obj->lcoord.coord.t[0]);
			dz = abs(objenemy->lcoord.coord.t[2] - obj->lcoord.coord.t[2]);
			if(dx<500 && dz<500 && objenemy->life > 0 && (objenemy->status == 0x00 || objenemy->status == 0x03)){
				OBJECT*obj2;
				objenemy->status = 0x01;
				sysw->numofhit++;
				snd_on(SND_ENEMY_DAMAGE_PUNCH2);	// 
				// Aj[V
				obj2 = create_object(ID_GsDOBJ2,KIND_OTHER,(void*)obj_bomb_animation,0,OBJECTMAX);
        	    GsInitCoordinate2(&(sysw->world),&(obj2->lcoord));
	   	        obj2->lcoord.coord.t[0] = objenemy->lcoord.coord.t[0];
   		        obj2->lcoord.coord.t[2] = objenemy->lcoord.coord.t[2];
				KsTMDLinkObject(obj2,(u_long*)BOMB_TMD_ADDR,&(obj2->lcoord));
				return objenemy;
			}
		}
	}

	return NULL;
}

static int obj_hit_kabe2(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
    int x1,x2,z1,z2;

    x1=(obj->lcoord.coord.t[0]+200)/2000;	x2=(obj->lcoord.coord.t[0]-200)/2000;
    z1=(obj->lcoord.coord.t[2]+200)/2000;	z2=(obj->lcoord.coord.t[2]-200)/2000;
    limitRange(x1,0,MAP_BLOCK_SIZE-1);		limitRange(x2,0,MAP_BLOCK_SIZE-1);
    limitRange(z1,0,MAP_BLOCK_SIZE-1);		limitRange(z2,0,MAP_BLOCK_SIZE-1);

    if((sysw->mapdata[x1][z1] & 8) && (sysw->mapdata[x2][z2] & 8) && (sysw->mapdata[x1][z2] & 8) && (sysw->mapdata[x2][z1] & 8)){
        if((sysw->mapdata[x1][z1] & 7)==1 && (sysw->mapdata[x2][z2] & 7)==1 && (sysw->mapdata[x2][z1] & 7)==1 && (sysw->mapdata[x1][z2] & 7)==1){
            if((sysw->mapdata[x1][z1]&0x40) && (sysw->mapdata[x2][z2]&0x40) && (sysw->mapdata[x2][z1]&0x40) && (sysw->mapdata[x1][z2]&0x40)){
            	if(sysw->mapdata[x1][z1]&0x20){
            		if((obj->lcoord.coord.t[2]-200 >= z1*2000+300) && (obj->lcoord.coord.t[2]+200 <= z1*2000+1700))	return 0;
            	}
            	if(sysw->mapdata[x1][z1]&0x10){
            		if((obj->lcoord.coord.t[0]-200 >= x1*2000+300) && (obj->lcoord.coord.t[0]+200 <= x1*2000+1700))	return 0;
            	}
                return 1;
            }else{
                return 1;
            }
        }
        return 0;
    }
    return 1;
}

//-----------------------------------------------------------------------
// ACe𓊂IuWFNg
// vC[ obj->rotate , obj->lcoord.coord[] pȂ΂ȂȂ
// ܂̃IuWFNg鑤łǂ 3DfgIɎw
//-----------------------------------------------------------------------
void obj_throw_item(OBJECT*obj)
{
	SYS_W*sysw=GetSystemWorkAddr();
	OBJECT*enemy;
	switch(obj->step){
	  case OBJ_INIT:
	  	obj->step = OBJ_MAIN;
   	    obj->lcoord.coord.t[0] -= rsin(obj->rotate)*500/ONE;
        obj->lcoord.coord.t[2] -= rcos(obj->rotate)*500/ONE;
        obj->lcoord.coord.t[1] = -1300;
        obj->lcoord.flg=0;
        obj->timer = 5 * 30; // 5 sec.
	  	break;
	  case OBJ_MAIN:
   	    obj->lcoord.coord.t[0] -= rsin(obj->rotate)*500/ONE;
        obj->lcoord.coord.t[2] -= rcos(obj->rotate)*500/ONE;
        RotMatrixY(256,&(obj->lcoord.coord));
        obj->lcoord.flg=0;
        enemy = obj_hit_enemy(obj);
        if(enemy!=NULL){
        	enemy->life-=2;
        	sysw->score += 100;
        	obj->step = OBJ_END;
        	break;
        }
        // ǂɂԂ
        if(obj_hit_kabe2(obj)){
        	OBJECT*obj2;
			// Aj[V
			obj2 = create_object(ID_GsDOBJ2,KIND_OTHER,(void*)obj_bomb_animation,0,OBJECTMAX);
       	    GsInitCoordinate2(&(sysw->world),&(obj2->lcoord));
   	        obj2->lcoord.coord.t[0] = obj->lcoord.coord.t[0];
			obj2->lcoord.coord.t[2] = obj->lcoord.coord.t[2];
			KsTMDLinkObject(obj2,(u_long*)BOMB_TMD_ADDR,&(obj2->lcoord));
        	obj->step = OBJ_END;
        }
        // Ԃ𒴂
        if(obj->timer-- <= 0) obj->step = OBJ_END;
        // }bv͈̔͂𒴂
        if((obj->lcoord.coord.t[0]<0)||(obj->lcoord.coord.t[0]>2000*MAP_BLOCK_SIZE)||(obj->lcoord.coord.t[2]<0)||(obj->lcoord.coord.t[2]>2000*MAP_BLOCK_SIZE))
        	obj->step = OBJ_END;
	  	break;
	  case OBJ_END:
	  	delete_object(obj->header.num);
	  	break;
	}
}
