#include "syswork.h"
#include "define.h"

u_long PadRead()
{
    SYS_W*sysw = GetSystemWorkAddr();
    return(~(*(sysw->padd0+3) | *(sysw->padd0+2) << 8 | *(sysw->padd1+3) << 16 | *(sysw->padd1+2) << 24));
}

//--------------------------------------
// VXe[Ñpbhf[^XV
//--------------------------------------
void getpad()
{
    SYS_W *sysw = GetSystemWorkAddr();
    u_long pad1,pad2;
    PAD_W *padw1 = &(sysw->padw[PAD1]);
    PAD_W *padw2 = &(sysw->padw[PAD2]);

    pad1 = pad2 = PadRead();
    pad1 &= 0x0000ffff;
    pad2 = (pad2 & 0xffff0000) >> 16;

    padw1->old = padw1->new;
    padw1->new = (short)pad1;
    padw2->old = padw2->new;
    padw2->new = (short)pad2;

    padw1->iskeydown = (~(padw1->old)) & (padw1->new);
    padw1->iskeyup   = (~(padw1->new)) & (padw1->old);
    padw2->iskeydown = (~(padw2->old)) & (padw2->new);
    padw2->iskeyup   = (~(padw2->new)) & (padw2->old);

}

//--------------
// pbh
//--------------
void PadInit()
{
    SYS_W*sysw = GetSystemWorkAddr();
    GetPadBuf(&(sysw->padd0), &(sysw->padd1));
}
