//------------------------
// TOD,TMD f[^̍\
//------------------------

#ifndef __TODTMDHD_H
#define __TODTMDHD_H

//-------------------
// TMDf[^̍\
//-------------------
typedef struct {
    u_long      id;             // ID tmdt@C 0x00000041
    u_long      flags;          // tO
    u_long      nobj;           // IuWFNǧ
} TMDHEADER;

//-------------------
// TODf[^̍\
//-------------------
typedef struct {
    u_char      id;             /* ID todt@C 0x50 */
    u_char      version;        /* o[W */
    u_short     resolution;     /* 1t[\Ă鎞 */
    u_long      nframes;        /* t[̐ */
} TODHEADER;

typedef struct {
    u_short     size;           /* t[TCY (Pʂ4byte) */
    u_short     packets;        /* pPbǧ */
    u_long      number;         /* t[ԍ */
} TODFRAMEHEADER;

typedef struct {
    u_short     id;             /* ΏۂƂȂIuWFNgIDԍ*/
    u_char      flagtype;       /*  flag(4bit)A type(4bit) */
    u_char      length ;        /* pPbg̃TCY (Pʂ4byte) */
} PACKETHEADER;

typedef struct {
    u_long      data;           /* pPbg̕Wf[^ */
} PACKETDATA;

typedef struct {
    u_short     tmdid;          /* TMDf[^ID */
    u_short     pad;
} PACKETDATA0010;

typedef struct {
    u_short     parentid;       /* eIuWFNgID */
    u_short     pad;
} PACKETDATA0011;

/* Coordinate ̃tOɂݒ */
/* flag:1110܂1111 */
typedef PACKETDATA0011 PACKETDATA0001;

typedef struct {
    long      rx;
    long      ry;
    long      rz;
    short     sx;
    short     sy;
    short     sz;
    short     pad;
    long      tx;
    long      ty;
    long      tz;
} PD0001FlagE_F;

/* flag:0110܂0111 */
typedef struct {
    long      rx;
    long      ry;
    long      rz;
    short     sx;
    short     sy;
    short     sz;
    short     pad;
} PD0001Flag6_7;

/* flag:1010܂1011 */
typedef struct {
    long      rx;
    long      ry;
    long      rz;
    long      tx;
    long      ty;
    long      tz;
} PD0001FlagA_B;

/* flag:1100܂1101 */
typedef struct {
    short     sx;
    short     sy;
    short     sz;
    short     pad;
    long      tx;
    long      ty;
    long      tz;
} PD0001FlagC_D;

/* flag:0010܂0011 */
typedef struct {
    long      rx;
    long      ry;
    long      rz;
} PD0001Flag2_3;

/* flag:0100܂0101 */
typedef struct {
    short     sx;
    short     sy;
    short     sz;
    short     pad;
} PD0001Flag4_5;

/* flag:1000܂1001 */
typedef struct {
    long      tx;
    long      ty;
    long      tz;
} PD0001Flag8_9;


#endif
